/*
 * View.java
 *
 * Created on 27 maggio 2005, 11.11
 */

package cleoni.adv;
import java.io.*;

/** This class is used to produce custom views for the game.
 *
 * You can implement a custom view by creating of a subclass of this one, and using
 * it in the multiplayer.service method.
 *
 * In future releases, custom views could be specified also via configuration so it
 * won't be acutally necessary to change and recopile source code.
 * @author Cristiano Leoni
 */
public class View {
    public static String htmlCharset(World world) {
        if (world == null)
            return "";
        else
            return world.htmlCharset();
    }

    public static void htmlWidthHeight(Image im, StringBuffer sb, double factorx) {
        int imwidth = im.getWidth();
        if (imwidth != 0) {
            sb.append("WIDTH=\"" + Utils.cInt(factorx*imwidth) + "\" HEIGHT=\"" + Utils.cInt(factorx*im.getHeight()) + "\" ");
        }
    }
    
    public static void htmlImage(Image im, StringBuffer sb, Client client, String alt) {
            double factorx = client.factorx;
                String src = im.getSrc();
                int p = Utils.instrRev(src, ".", false /* check case */);
                String extension = "";
                if (p>0) {
                    extension = src.substring(p+1,src.length()); 
                }
                if (extension.equalsIgnoreCase("MOV")) { 
                    sb.append("<OBJECT CLASSID=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" ");
                    htmlWidthHeight(im,sb,factorx);
                    sb.append("CODEBASE=\"http://www.apple.com/qtactivex/qtplugin.cab\">");
                    sb.append("<PARAM name=\"SRC\" VALUE=\""+ im.getSrc() + "\">");
                    sb.append("<PARAM name=\"AUTOPLAY\" VALUE=\"true\">\n<PARAM name=\"CONTROLLER\" VALUE=\"false\">");
                    sb.append("<EMBED SRC=\""+ im.getSrc() + "\" ");
                    htmlWidthHeight(im,sb,factorx);
                    sb.append("AUTOPLAY=\"true\" CONTROLLER=\"false\" PLUGINSPAGE=\"http://www.apple.com/quicktime/download/\"></EMBED>\n</OBJECT>");
                } else if (extension.equalsIgnoreCase("SWF")) {
                    sb.append("<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" ");
                    htmlWidthHeight(im,sb,factorx);
                    sb.append("codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,29,0\">");
                    sb.append("<param name=\"movie\" value=\"" + im.getSrc() + "\">");  
                    sb.append("<param name=\"quality\" value=\"high\">");
                    sb.append("<EMBED SRC=\""+ im.getSrc() + "\" ");
                    htmlWidthHeight(im,sb,factorx);
                    sb.append("quality=\"high\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" type=\"application/x-shockwave-flash\"></EMBED>\n</OBJECT>");
                } else if (extension.equalsIgnoreCase("MPG") || extension.equalsIgnoreCase("MPEG")) {
                    //sb.append("<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" ");
                    //htmlWidthHeight(im,sb,factorx);
                    //sb.append("codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,29,0\">");
                    //sb.append("<param name=\"movie\" value=\"" + im.src + "\">");  
                    //sb.append("<param name=\"quality\" value=\"high\">");
                    sb.append("<EMBED SRC=\""+ im.getSrc() + "\" ");
                    htmlWidthHeight(im,sb,factorx);
                    sb.append("AUTOSTART=\"true\"");
                    sb.append("SHOWCONTROLS=\"false\"");
                    sb.append("AUTOPLAY=\"1\"");
                    sb.append("LOOP=\"1\"");
                    sb.append("pluginspage=\"http://www.apple.com/quicktime/download/\"</EMBED>\n</OBJECT>");
                } else {
                    sb.append("<IMG BORDER=0 ");
                    htmlWidthHeight(im,sb,factorx);
                    sb.append("SRC=\""+ im.getSrc() + "\" ALT=\"" + alt + "\" TITLE=\"" + alt + "\">");
                }
    }
    public static void outputHtml(World world, PrintWriter out, Skin skin)  throws DimxException {
        out.println("undefined");
    }
    public static void outputHtml(World world, PrintWriter out, Player thisPlayer, Skin skin, String commands) throws DimxException {
        out.println("undefined");
    }
}
